import "core-js/modules/es.regexp.exec.js";
import "core-js/modules/es.string.replace.js";
import "core-js/modules/es.array.for-each.js";
import "core-js/modules/es.object.to-string.js";
import "core-js/modules/web.dom-collections.for-each.js";
import "core-js/modules/es.object.keys.js";
import "core-js/modules/es.function.name.js";
export default function (babel) {
  var t = babel.types;
  var traversalHandler = {
    ReferencedIdentifier: function ReferencedIdentifier(path) {
      var node = path.node;
      if (t.isIdentifier(node, {
        name: "text"
      }) && !t.isMemberExpression(path.parent)) {
        var newNode = t.memberExpression(t.identifier("object"), t.identifier("property"));
        if (t.isVariableDeclarator(path.parent)) {
          if (t.isIdentifier(path.parent.init, {
            name: "text"
          })) {}
        } else {
          path.replaceWith(this.replace);
        }
      }
    }
  };
  var updateParamNameVisitor = {
    VariableDeclaration: function VariableDeclaration(path) {
      var scope = path.scope,
        node = path.node;
      node.declarations.forEach(function (decl) {
        if (t.isMemberExpression(decl.init) && t.isIdentifier(decl.init.object, {
          name: "Props"
        })) {
          Object.keys(scope.bindings).forEach(function (key) {});
          path.parentPath.traverse(traversalHandler, {
            varName: node.name,
            replace: decl.init
          });
          // path.remove();
        }
      });
    }
  };

  return {
    name: "ast-transform",
    // not required
    visitor: {
      FunctionDeclaration: function FunctionDeclaration(path) {
        var scope = path.scope,
          node = path.node;
        var param = node.params[0];
        if (param.name != "Props") {
          return;
        }
        if (!path.scope.hasOwnBinding("Props")) {
          return;
        }

        // parent is a path
        var parent = scope.getBinding("Props").referencePaths[1].findParent(function (path) {
          return path.isVariableDeclarator() && path.scope == scope;
        });
        var insert = parent.node.init;
        console.log(parent); // scope.bindings["text"].referencePaths) 

        scope.bindings["children"].referencePaths.forEach(function (path) {
          return path.replaceWith(insert);
        });
        scope.getBinding("Props").path.traverse(updateParamNameVisitor, {
          paramName: param.name
        });
      }
    }
  };
}